#define BOOST_AUTO_TEST_MAIN
#include <boost/test/auto_unit_test.hpp>

#include <boost/archive/text_oarchive.hpp>
#include <boost/archive/text_iarchive.hpp>
#include <boost/archive/xml_oarchive.hpp>
#include <boost/archive/xml_iarchive.hpp>

#include "alg/alphabet.hpp"
#include "mussa_exceptions.hpp"

BOOST_AUTO_TEST_CASE( alphabet_simple )
{
  Alphabet a(Alphabet::reduced_dna_alphabet());
  // exists is case insensitive
  BOOST_CHECK_EQUAL( a.exists('a'), true);
  BOOST_CHECK_EQUAL( a.exists('A'), true);
  BOOST_CHECK_EQUAL( a.exists('Q'), false);
  BOOST_CHECK_EQUAL( a.exists('q'), false);
  
  // copied from alphabet.cpp
  BOOST_CHECK_EQUAL( Alphabet::reduced_dna_cstr, "AaCcGgTtNn\012\015");
}
